/*
 * автор Стрельцов Игорь
 * создано 25.07.2019
 * Урок № 1
 * Используем функцию millis()
 * Мигаем светодиодом.
 * 
 */
#define LED 13
#define STOP 1000 // 1000 миллисекунд - это 1 секунды

unsigned long prev_ms = 0;      // В этой переменной будет храниться время последнего изменения состояния светодиода 

void setup() {
  pinMode(LED, OUTPUT); // УСТАНАВЛИВАЕМ ЦИФРОВОЙ ПИН 13 НА ВЫХОД
}

void loop()
{
  /*
    проверяем – настало ли время изменить состояние светодиода
    для этого считываем значение светодиода digitalRead(LED),      
    а затем сверяем полученный интервал с нужным интервалом 
  */
if (millis() - prev_ms > STOP) { 
// текущее время –(минус) время последнего изменения. Если он больше 1000(1 сек.) то условие верно        
    digitalWrite(LED, !digitalRead(LED)); // если светодиод был выключен – включаем и наоборот
   prev_ms = millis();// Записываем в переменную текущее время
  }
/*
 Здесь могут быть другие команды, которые нужно выполнить и неважно, что будет делать микроконтроллер в данное время,
 Если настало время STOP, он прервётся, выполнит задачу, и начнёт с того же места, где прервался.
*/
}
